Prime Path【广搜】

Prime Path

 POJ - 3126 

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 

1033 
1733 
3733 
3739 
3779 
8779 
8179

The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0

题意:给两个质数n,m,每次只能改变n中的一个数字且改变后的数字依旧是一个质数,问最少需要多少步可以将n变成m。

方法:此题需要先打出一个素数表,然后在广搜,分别将n中的每一位遍历即可。

AC代码:

#include 
#include 
#include 
#include 
#include 
#include 
#include 
#include 
#include 
#include 
#include 
#include 
#include 
using namespace std;
typedef long long ll;
#define inf 0x3f3f3f3f
#define rep(i,l,r) for(int i=l;i<=r;i++)
#define lep(i,l,r) for(int i=l;i>=r;i--)
#define ms(arr) memset(arr,0,sizeof(arr))
//priority_queue ,greater >q;
const int maxn = (int)1e5 + 5;
const ll mod = 1e9+7;
bool vis[maxn];
int prime[maxn];
int v1[maxn];
int plen;
void getp()
{
	for(int i=2;i<=10000;i++)
	{
		if(!v1[i])
		{
			prime[plen]=i;
			plen++;
			v1[i]=1;
			int q=i;
			while(q<=10000)
			{
				v1[q]=1;
				q=q+i;
			}
		}
	}
	for(int i=0;i1000)
			vis[prime[i]]=true;
	}
}
bool vi[maxn];
int u,v;
struct node
{
	int x;
	int step;
}pn[maxn];
int bfs(int x)
{
	queueq;
	pn[0].x=x;
	pn[0].step=0;
	q.push(pn[0]);
	vi[x]=true;
	while(!q.empty())
	{
		node front=q.front();
		node tail;
		q.pop();
		int num[4];
		int t=0;
		while(front.x)
		{
			num[t]=front.x%10;
			front.x=front.x/10;
			t++;
		}
		int nape;
		for(int i=1;i<=9;i++)
		{
			nape=i*1000+num[2]*100+num[1]*10+num[0];
			if(vi[nape]==false&&vis[nape]==true)
			{
				tail.x=nape;
				tail.step=front.step+1;
				vi[nape]=true;
				q.push(tail);
				if(tail.x==v)
					return tail.step;
			}
		}
		for(int i=0;i<=9;i++)
		{
			nape=i*100+num[3]*1000+num[1]*10+num[0];
			if(vi[nape]==false&&vis[nape]==true)
			{
				tail.x=nape;
				tail.step=front.step+1;
				vi[nape]=true;
				q.push(tail);
				if(tail.x==v)
					return tail.step;
			}
		}
		for(int i=0;i<=9;i++)
		{
			nape=i*10+num[3]*1000+num[2]*100+num[0];
			if(vi[nape]==false&&vis[nape]==true)
			{
				tail.x=nape;
				tail.step=front.step+1;
				vi[nape]=true;
				q.push(tail);
				if(tail.x==v)
					return tail.step;
			}
		}
		for(int i=0;i<=9;i++)
		{
			nape=i+num[3]*1000+num[2]*100+num[1]*10;
			if(vi[nape]==false&&vis[nape]==true)
			{
				tail.x=nape;
				tail.step=front.step+1;
				vi[nape]=true;
				q.push(tail);
				if(tail.x==v)
					return tail.step;
			}
		}
	}
}
int main() 
{
    //freopen("in.txt", "r", stdin);
    //freopen("out.txt", "w", stdout);
    ios::sync_with_stdio(0),cin.tie(0);
    getp();
    int n;
    scanf("%d",&n);
    while(n--)
    {
    	scanf("%d %d",&u,&v);
    	ms(vi);
    	memset(pn,0,sizeof(pn));
    	if(u==v)
    		printf("0\n");
    	else
    		printf("%d\n",bfs(u));
    }
    return 0;
}

 

你可能感兴趣的:(搜索,步于C++)